SystemOrganization addCategory: #AMMStudio!
SystemOrganization addCategory: #'AMMStudio-Test'!

NCSimulatedAnnealingGraphLayoutAlgorithm subclass: #AMMGraphLayoutAlgorithm
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMGraphLayoutAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 13:33:02.774'!
aeMinEdgeLength
	"sw: I had to change this, hence errors came up, after removing the PasteUpMorph, although the layout algorithm is still active."
	
	"I am an aesthetic that causes edges to be shortened. My magnitude is d^2, where d is the magnitude of the distance between nodes. Since I consider all edges, my time complexity is O(|E|)"

	| retval |
	retval := IdentityDictionary 
				newFrom: (self nodes collect: [:node | node -> (0 @ 0)]).
	self edges do: 
			[:edge | 
			| fromNode toNode delta mag force |
			fromNode := edge startConnection.
			toNode := edge endConnection.
			((fromNode isNil) or: toNode isNil) ifFalse: [
				delta := toNode center - fromNode center.
				delta := delta / scale.
				mag := delta r.
				force := mag * delta.
				retval at: fromNode put: (retval at: fromNode) + force.
				retval at: toNode put: (retval at: toNode) - force].
			].	

   ^self nodes collect: [:ea | retval at: ea]! !

!AMMGraphLayoutAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 13:33:02.784'!
aeNodeRepulsion
	"I am an aesthetic that attempts to keep nodes apart. My magnitude is 1/d^2, where d is the magnitude of the distance between nodes. Since I consider all node combinations, my time complexity is O(|V|^2)"

	| retval |
	retval := Array new: self nodes size withAll: 0.0 @ 0.0.
	(1 to: self nodes size) combinations: 2
		atATimeDo: 
			[:arr | 
			| ai1 ai2 node otherNode delta mag2 force |
			 "self halt."
			node := self nodes at: (ai1 := arr at: 1).
			otherNode := self nodes at: (ai2 := arr at: 2).
			delta := (node center - otherNode center) asFloatPoint.
			delta := (delta / scale) + 0.001.
			mag2 := delta x * delta x + (delta y * delta y) max: 1.0e-8.
			force := 1.0 / mag2 * delta.
			retval at: ai1 put: (retval at: ai1) + force.
			retval at: ai2 put: (retval at: ai2) - force].
	^retval! !

!AMMGraphLayoutAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 13:33:02.794'!
layoutMorph: aPasteUpMorph 
	aPasteUpMorph allConnectedMorphs isEmpty ifFalse: [
		^ super layoutMorph: aPasteUpMorph
		]! !

UserInterface subclass: #AMMStudioUi
	instanceVariableNames: 'comboUnits buttonPlay buttonStep descriptionField buttonNext containerHeap containerGraph scrollAreaGraph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMStudioUi methodsFor: 'accessing' stamp: 'sw 5/16/2013 10:47:10.195'!
buttonNext
	"No description given."
	
	^ buttonNext! !

!AMMStudioUi methodsFor: 'accessing' stamp: 'sw 5/16/2013 10:47:10.188'!
buttonPlay
	"Play Scenario"
	
	^ buttonPlay! !

!AMMStudioUi methodsFor: 'accessing' stamp: 'sw 5/16/2013 10:47:10.19'!
buttonStep
	"GC Stepping"
	
	^ buttonStep! !

!AMMStudioUi methodsFor: 'accessing' stamp: 'sw 5/16/2013 10:47:10.186'!
comboUnits
	"No description given."
	
	^ comboUnits! !

!AMMStudioUi methodsFor: 'accessing' stamp: 'sw 5/16/2013 10:47:10.199'!
containerGraph
	"No description given."
	
	^ containerGraph! !

!AMMStudioUi methodsFor: 'accessing' stamp: 'sw 5/16/2013 10:47:10.197'!
containerHeap
	"Container for the heap presentation"
	
	^ containerHeap! !

!AMMStudioUi methodsFor: 'accessing' stamp: 'sw 5/16/2013 10:47:10.193'!
descriptionField
	"No description given."
	
	^ descriptionField! !

!AMMStudioUi methodsFor: 'ui - private' stamp: 'sw 5/16/2013 10:47:10.233'!
initializePanel
	"This code is auto-generated. DO NOT modify it because another generation step will overwrite all changes."
	
	| unnamedMorph1 unnamedMorph2 unnamedMorph3 unnamedMorph4 unnamedMorph5 |
	
	panel := UiContainer new.
	panel changeTableLayout.
	panel extent: (500@466).
	panel position: (0@0).
	panel hResizing: (#rigid).
	panel vResizing: (#shrinkWrap).
	panel minWidth: (2).
	panel minHeight: (2).
	panel cellInset: (4).
	panel cellPositioning: (#topLeft).
	panel cellSpacing: (#none).
	panel layoutInset: (4).
	panel listCentering: (#topLeft).
	panel listDirection: (#leftToRight).
	panel listSpacing: (#none).
	panel maxCellSize: (1073741823).
	panel minCellSize: (0).
	panel wrapCentering: (#topLeft).
	panel wrapDirection: (#none).
	panel frameFractions: (0@0 corner: 1@1).
	panel frameOffsets: (0@0 corner: 0@0).
	panel balloonText: (nil).
	panel balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	panel color: (Color transparent).
	panel borderWidth: (0).
	panel borderStyle2: (#simple).
	panel borderColor: (Color black).
	panel setProperty: #objectName toValue: 'panel'.
	unnamedMorph1 := UiContainer new.
	unnamedMorph1 changeTableLayout.
	unnamedMorph1 extent: (385@458).
	unnamedMorph1 position: (4@4).
	unnamedMorph1 hResizing: (#spaceFill).
	unnamedMorph1 vResizing: (#spaceFill).
	unnamedMorph1 minWidth: (300).
	unnamedMorph1 minHeight: (2).
	unnamedMorph1 cellInset: (4).
	unnamedMorph1 cellPositioning: (#center).
	unnamedMorph1 cellSpacing: (#none).
	unnamedMorph1 layoutInset: (4).
	unnamedMorph1 listCentering: (#topLeft).
	unnamedMorph1 listDirection: (#topToBottom).
	unnamedMorph1 listSpacing: (#none).
	unnamedMorph1 maxCellSize: (1073741823).
	unnamedMorph1 minCellSize: (0).
	unnamedMorph1 wrapCentering: (#topLeft).
	unnamedMorph1 wrapDirection: (#none).
	unnamedMorph1 frameFractions: (0@0 corner: 1@1).
	unnamedMorph1 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph1 balloonText: (nil).
	unnamedMorph1 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.941)).
	unnamedMorph1 color: (Color transparent).
	unnamedMorph1 borderWidth: (0).
	unnamedMorph1 borderStyle2: (#simple).
	unnamedMorph1 borderColor: (Color black).
	unnamedMorph2 := UiContainer new.
	unnamedMorph2 changeTableLayout.
	unnamedMorph2 extent: (377@30).
	unnamedMorph2 position: (8@8).
	unnamedMorph2 hResizing: (#spaceFill).
	unnamedMorph2 vResizing: (#shrinkWrap).
	unnamedMorph2 minWidth: (2).
	unnamedMorph2 minHeight: (2).
	unnamedMorph2 cellInset: (4).
	unnamedMorph2 cellPositioning: (#topLeft).
	unnamedMorph2 cellSpacing: (#none).
	unnamedMorph2 layoutInset: (4).
	unnamedMorph2 listCentering: (#topLeft).
	unnamedMorph2 listDirection: (#leftToRight).
	unnamedMorph2 listSpacing: (#none).
	unnamedMorph2 maxCellSize: (1073741823).
	unnamedMorph2 minCellSize: (0).
	unnamedMorph2 wrapCentering: (#topLeft).
	unnamedMorph2 wrapDirection: (#none).
	unnamedMorph2 frameFractions: (0@0 corner: 1@1).
	unnamedMorph2 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph2 balloonText: (nil).
	unnamedMorph2 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.937)).
	unnamedMorph2 color: (Color transparent).
	unnamedMorph2 borderWidth: (0).
	unnamedMorph2 borderStyle2: (#simple).
	unnamedMorph2 borderColor: (Color black).
	unnamedMorph2 setProperty: #objectDescription toValue: 'Container for the heap presentation'.
	comboUnits := UiComboBox new.
	comboUnits extent: (110@21).
	comboUnits position: (12@12).
	comboUnits hResizing: (#rigid).
	comboUnits vResizing: (#rigid).
	comboUnits minWidth: (2).
	comboUnits minHeight: (2).
	comboUnits cellInset: (0).
	comboUnits cellPositioning: (#center).
	comboUnits cellSpacing: (#none).
	comboUnits layoutInset: (0).
	comboUnits listCentering: (#topLeft).
	comboUnits listDirection: (#topToBottom).
	comboUnits listSpacing: (#none).
	comboUnits maxCellSize: (1073741823).
	comboUnits minCellSize: (0).
	comboUnits wrapCentering: (#topLeft).
	comboUnits wrapDirection: (#none).
	comboUnits frameFractions: (0@0 corner: 1@1).
	comboUnits frameOffsets: (0@0 corner: 0@0).
	comboUnits balloonText: (nil).
	comboUnits balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.937)).
	comboUnits readOnly: (true).
	comboUnits setProperty: #objectName toValue: 'comboUnits'.
	unnamedMorph2 addChild: comboUnits.
	buttonPlay := UiPushButton new.
	buttonPlay changeTableLayout.
	buttonPlay extent: (49@21).
	buttonPlay position: (128@12).
	buttonPlay hResizing: (#shrinkWrap).
	buttonPlay vResizing: (#shrinkWrap).
	buttonPlay minWidth: (2).
	buttonPlay minHeight: (2).
	buttonPlay cellInset: (4).
	buttonPlay cellPositioning: (#center).
	buttonPlay cellSpacing: (#none).
	buttonPlay layoutInset: (2@0 corner: 2@0).
	buttonPlay listCentering: (#topLeft).
	buttonPlay listDirection: (#leftToRight).
	buttonPlay listSpacing: (#none).
	buttonPlay maxCellSize: (1073741823).
	buttonPlay minCellSize: (0).
	buttonPlay wrapCentering: (#topLeft).
	buttonPlay wrapDirection: (#none).
	buttonPlay frameFractions: (0@0 corner: 1@1).
	buttonPlay frameOffsets: (0@0 corner: 0@0).
	buttonPlay balloonText: (nil).
	buttonPlay balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.933)).
	buttonPlay enabled: (true).
	buttonPlay setProperty: #iconByDesigner toValue: 'UiDiagonaIcons icon0331Normal'.
	buttonPlay icon: (UiDiagonaIcons icon0331Normal).
	buttonPlay text: ('Play').
	buttonPlay color: ((Color r: 0.8 g: 0.8 b: 0.8)).
	buttonPlay checkable: (false).
	buttonPlay checked: (false).
	buttonPlay autoExclusive: (false).
	buttonPlay setProperty: #objectName toValue: 'buttonPlay'.
	buttonPlay setProperty: #objectDescription toValue: 'Play Scenario'.
	unnamedMorph2 addChild: buttonPlay.
	buttonStep := UiPushButton new.
	buttonStep changeTableLayout.
	buttonStep extent: (52@21).
	buttonStep position: (183@12).
	buttonStep hResizing: (#shrinkWrap).
	buttonStep vResizing: (#shrinkWrap).
	buttonStep minWidth: (2).
	buttonStep minHeight: (2).
	buttonStep cellInset: (4).
	buttonStep cellPositioning: (#center).
	buttonStep cellSpacing: (#none).
	buttonStep layoutInset: (2@0 corner: 2@0).
	buttonStep listCentering: (#topLeft).
	buttonStep listDirection: (#leftToRight).
	buttonStep listSpacing: (#none).
	buttonStep maxCellSize: (1073741823).
	buttonStep minCellSize: (0).
	buttonStep wrapCentering: (#topLeft).
	buttonStep wrapDirection: (#none).
	buttonStep frameFractions: (0@0 corner: 1@1).
	buttonStep frameOffsets: (0@0 corner: 0@0).
	buttonStep balloonText: (nil).
	buttonStep balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.937)).
	buttonStep enabled: (true).
	buttonStep setProperty: #iconByDesigner toValue: 'UiDiagonaIcons icon0346Normal'.
	buttonStep icon: (UiDiagonaIcons icon0346Normal).
	buttonStep text: ('Step').
	buttonStep color: ((Color r: 0.8 g: 0.8 b: 0.8)).
	buttonStep checkable: (false).
	buttonStep checked: (false).
	buttonStep autoExclusive: (false).
	buttonStep setProperty: #objectName toValue: 'buttonStep'.
	buttonStep setProperty: #objectDescription toValue: 'GC Stepping'.
	unnamedMorph2 addChild: buttonStep.
	unnamedMorph1 addChild: unnamedMorph2.
	unnamedMorph3 := UiContainer new.
	unnamedMorph3 changeTableLayout.
	unnamedMorph3 extent: (377@415).
	unnamedMorph3 position: (8@43).
	unnamedMorph3 hResizing: (#spaceFill).
	unnamedMorph3 vResizing: (#spaceFill).
	unnamedMorph3 minWidth: (2).
	unnamedMorph3 minHeight: (2).
	unnamedMorph3 cellInset: (4).
	unnamedMorph3 cellPositioning: (#center).
	unnamedMorph3 cellSpacing: (#none).
	unnamedMorph3 layoutInset: (4).
	unnamedMorph3 listCentering: (#topLeft).
	unnamedMorph3 listDirection: (#topToBottom).
	unnamedMorph3 listSpacing: (#none).
	unnamedMorph3 maxCellSize: (1073741823).
	unnamedMorph3 minCellSize: (0).
	unnamedMorph3 wrapCentering: (#topLeft).
	unnamedMorph3 wrapDirection: (#none).
	unnamedMorph3 frameFractions: (0@0 corner: 1@1).
	unnamedMorph3 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph3 balloonText: (nil).
	unnamedMorph3 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.941)).
	unnamedMorph3 color: (Color transparent).
	unnamedMorph3 borderWidth: (0).
	unnamedMorph3 borderStyle2: (#simple).
	unnamedMorph3 borderColor: (Color black).
	descriptionField := UiTextEdit new.
	descriptionField extent: (369@373).
	descriptionField position: (12@47).
	descriptionField hResizing: (#spaceFill).
	descriptionField vResizing: (#spaceFill).
	descriptionField minWidth: (2).
	descriptionField minHeight: (2).
	descriptionField cellInset: (0).
	descriptionField cellPositioning: (#center).
	descriptionField cellSpacing: (#none).
	descriptionField layoutInset: (0).
	descriptionField listCentering: (#topLeft).
	descriptionField listDirection: (#topToBottom).
	descriptionField listSpacing: (#none).
	descriptionField maxCellSize: (1073741823).
	descriptionField minCellSize: (0).
	descriptionField wrapCentering: (#topLeft).
	descriptionField wrapDirection: (#none).
	descriptionField frameFractions: (0@0 corner: 1@1).
	descriptionField frameOffsets: (0@0 corner: 0@0).
	descriptionField balloonText: (nil).
	descriptionField balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.937)).
	descriptionField widgetResizable: (true).
	descriptionField horizontalScrollBarPolicy: (#alwaysOff).
	descriptionField verticalScrollBarPolicy: (#alwaysOn).
	descriptionField outerBorderWidth: (1).
	descriptionField scrollBarThickness: (9).
	descriptionField theText: ('').
	descriptionField readOnly: (false).
	descriptionField autoConvert: (false).
	descriptionField autoAccept: (false).
	descriptionField acceptOnFocusLost: (false).
	descriptionField scrollingMode: (#none).
	descriptionField scrollingLimit: (10).
	descriptionField setProperty: #objectName toValue: 'descriptionField'.
	unnamedMorph3 addChild: descriptionField.
	unnamedMorph4 := UiContainer new.
	unnamedMorph4 changeTableLayout.
	unnamedMorph4 extent: (369@30).
	unnamedMorph4 position: (12@424).
	unnamedMorph4 hResizing: (#spaceFill).
	unnamedMorph4 vResizing: (#rigid).
	unnamedMorph4 minWidth: (2).
	unnamedMorph4 minHeight: (2).
	unnamedMorph4 cellInset: (4).
	unnamedMorph4 cellPositioning: (#center).
	unnamedMorph4 cellSpacing: (#none).
	unnamedMorph4 layoutInset: (4).
	unnamedMorph4 listCentering: (#topLeft).
	unnamedMorph4 listDirection: (#topToBottom).
	unnamedMorph4 listSpacing: (#none).
	unnamedMorph4 maxCellSize: (1073741823).
	unnamedMorph4 minCellSize: (0).
	unnamedMorph4 wrapCentering: (#topLeft).
	unnamedMorph4 wrapDirection: (#none).
	unnamedMorph4 frameFractions: (0@0 corner: 1@1).
	unnamedMorph4 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph4 balloonText: (nil).
	unnamedMorph4 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.945)).
	unnamedMorph4 color: (Color transparent).
	unnamedMorph4 borderWidth: (0).
	unnamedMorph4 borderStyle2: (#simple).
	unnamedMorph4 borderColor: (Color black).
	buttonNext := UiPushButton new.
	buttonNext changeTableLayout.
	buttonNext extent: (30@21).
	buttonNext position: (16@428).
	buttonNext hResizing: (#shrinkWrap).
	buttonNext vResizing: (#shrinkWrap).
	buttonNext minWidth: (2).
	buttonNext minHeight: (2).
	buttonNext cellInset: (4).
	buttonNext cellPositioning: (#center).
	buttonNext cellSpacing: (#none).
	buttonNext layoutInset: (2@0 corner: 2@0).
	buttonNext listCentering: (#topLeft).
	buttonNext listDirection: (#leftToRight).
	buttonNext listSpacing: (#none).
	buttonNext maxCellSize: (1073741823).
	buttonNext minCellSize: (0).
	buttonNext wrapCentering: (#topLeft).
	buttonNext wrapDirection: (#none).
	buttonNext frameFractions: (0@0 corner: 1@1).
	buttonNext frameOffsets: (0@0 corner: 0@0).
	buttonNext balloonText: (nil).
	buttonNext balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.941)).
	buttonNext enabled: (true).
	buttonNext setProperty: #iconByDesigner toValue: 'nil'.
	buttonNext icon: (nil).
	buttonNext text: ('next').
	buttonNext color: ((Color r: 0.8 g: 0.8 b: 0.8)).
	buttonNext checkable: (false).
	buttonNext checked: (false).
	buttonNext autoExclusive: (false).
	buttonNext setProperty: #objectName toValue: 'buttonNext'.
	unnamedMorph4 addChild: buttonNext.
	unnamedMorph3 addChild: unnamedMorph4.
	unnamedMorph1 addChild: unnamedMorph3.
	panel addChild: unnamedMorph1.
	unnamedMorph5 := UiContainer new.
	unnamedMorph5 changeTableLayout.
	unnamedMorph5 extent: (103@458).
	unnamedMorph5 position: (393@4).
	unnamedMorph5 hResizing: (#spaceFill).
	unnamedMorph5 vResizing: (#spaceFill).
	unnamedMorph5 minWidth: (2).
	unnamedMorph5 minHeight: (2).
	unnamedMorph5 cellInset: (4).
	unnamedMorph5 cellPositioning: (#center).
	unnamedMorph5 cellSpacing: (#none).
	unnamedMorph5 layoutInset: (4).
	unnamedMorph5 listCentering: (#topLeft).
	unnamedMorph5 listDirection: (#topToBottom).
	unnamedMorph5 listSpacing: (#none).
	unnamedMorph5 maxCellSize: (1073741823).
	unnamedMorph5 minCellSize: (0).
	unnamedMorph5 wrapCentering: (#topLeft).
	unnamedMorph5 wrapDirection: (#none).
	unnamedMorph5 frameFractions: (0@0 corner: 1@1).
	unnamedMorph5 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph5 balloonText: (nil).
	unnamedMorph5 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.937)).
	unnamedMorph5 color: (Color transparent).
	unnamedMorph5 borderWidth: (0).
	unnamedMorph5 borderStyle2: (#simple).
	unnamedMorph5 borderColor: (Color black).
	containerHeap := UiContainer new.
	containerHeap changeTableLayout.
	containerHeap extent: (95@100).
	containerHeap position: (397@8).
	containerHeap hResizing: (#spaceFill).
	containerHeap vResizing: (#rigid).
	containerHeap minWidth: (2).
	containerHeap minHeight: (2).
	containerHeap cellInset: (4).
	containerHeap cellPositioning: (#center).
	containerHeap cellSpacing: (#none).
	containerHeap layoutInset: (4).
	containerHeap listCentering: (#topLeft).
	containerHeap listDirection: (#topToBottom).
	containerHeap listSpacing: (#none).
	containerHeap maxCellSize: (1073741823).
	containerHeap minCellSize: (0).
	containerHeap wrapCentering: (#topLeft).
	containerHeap wrapDirection: (#none).
	containerHeap frameFractions: (0@0 corner: 1@1).
	containerHeap frameOffsets: (0@0 corner: 0@0).
	containerHeap balloonText: (nil).
	containerHeap balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	containerHeap color: (Color lightGray).
	containerHeap borderWidth: (0).
	containerHeap borderStyle2: (#simple).
	containerHeap borderColor: (Color black).
	containerHeap setProperty: #objectName toValue: 'containerHeap'.
	containerHeap setProperty: #objectDescription toValue: 'Container for the heap presentation'.
	unnamedMorph5 addChild: containerHeap.
	containerGraph := UiContainer new.
	containerGraph changeTableLayout.
	containerGraph extent: (95@346).
	containerGraph position: (397@112).
	containerGraph hResizing: (#spaceFill).
	containerGraph vResizing: (#spaceFill).
	containerGraph minWidth: (2).
	containerGraph minHeight: (2).
	containerGraph cellInset: (4).
	containerGraph cellPositioning: (#center).
	containerGraph cellSpacing: (#none).
	containerGraph layoutInset: (4).
	containerGraph listCentering: (#topLeft).
	containerGraph listDirection: (#topToBottom).
	containerGraph listSpacing: (#none).
	containerGraph maxCellSize: (1073741823).
	containerGraph minCellSize: (0).
	containerGraph wrapCentering: (#topLeft).
	containerGraph wrapDirection: (#none).
	containerGraph frameFractions: (0@0 corner: 1@1).
	containerGraph frameOffsets: (0@0 corner: 0@0).
	containerGraph balloonText: (nil).
	containerGraph balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.937)).
	containerGraph color: (Color lightGray).
	containerGraph borderWidth: (0).
	containerGraph borderStyle2: (#simple).
	containerGraph borderColor: (Color black).
	containerGraph setProperty: #objectName toValue: 'containerGraph'.
	scrollAreaGraph := ViScrollArea new.
	scrollAreaGraph extent: (87@338).
	scrollAreaGraph position: (401@116).
	scrollAreaGraph hResizing: (#spaceFill).
	scrollAreaGraph vResizing: (#spaceFill).
	scrollAreaGraph minWidth: (2).
	scrollAreaGraph minHeight: (2).
	scrollAreaGraph cellInset: (0).
	scrollAreaGraph cellPositioning: (#center).
	scrollAreaGraph cellSpacing: (#none).
	scrollAreaGraph layoutInset: (0).
	scrollAreaGraph listCentering: (#topLeft).
	scrollAreaGraph listDirection: (#topToBottom).
	scrollAreaGraph listSpacing: (#none).
	scrollAreaGraph maxCellSize: (1073741823).
	scrollAreaGraph minCellSize: (0).
	scrollAreaGraph wrapCentering: (#topLeft).
	scrollAreaGraph wrapDirection: (#none).
	scrollAreaGraph frameFractions: (0@0 corner: 1@1).
	scrollAreaGraph frameOffsets: (0@0 corner: 0@0).
	scrollAreaGraph balloonText: (nil).
	scrollAreaGraph balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.937)).
	scrollAreaGraph widgetResizable: (false).
	scrollAreaGraph horizontalScrollBarPolicy: (#alwaysOn).
	scrollAreaGraph verticalScrollBarPolicy: (#alwaysOn).
	scrollAreaGraph outerBorderWidth: (0).
	scrollAreaGraph scrollBarThickness: (9).
	scrollAreaGraph setProperty: #objectName toValue: 'scrollAreaGraph'.
	containerGraph addChild: scrollAreaGraph.
	unnamedMorph5 addChild: containerGraph.
	panel addChild: unnamedMorph5.
	panel setProperty: #uiClassName toValue: 'AMMStudio'.! !

!AMMStudioUi methodsFor: 'accessing' stamp: 'sw 5/16/2013 10:47:10.201'!
scrollAreaGraph
	"No description given."
	
	^ scrollAreaGraph! !

Morph subclass: #AMMStudio
	instanceVariableNames: 'ui heap objectgraph currentUnit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMStudio class methodsFor: 'as yet unclassified' stamp: 'sw 5/9/2013 11:19:33.161'!
open

	^ self new open.! !

!AMMStudio methodsFor: 'accessing' stamp: 'sw 5/13/2013 11:48:54.013'!
currentUnit

	^ currentUnit! !

!AMMStudio methodsFor: 'accessing' stamp: 'sw 5/13/2013 11:49:15.468'!
currentUnit: anAMMUnit

	currentUnit := anAMMUnit! !

!AMMStudio methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 13:45:01.765'!
gcStep

	self currentUnit step.
	self refreshObjectRepresentations.! !

!AMMStudio methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 13:53:16.717'!
heap

	^ heap! !

!AMMStudio methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 13:54:09.601'!
heap: aHeap

	heap := aHeap! !

!AMMStudio methodsFor: 'as yet unclassified' stamp: 'sw 5/16/2013 10:49:29.315'!
initialize 

	super initialize.
	self ui setupUi: self.

	self registerSignalsForGeneralControls.
	self initializeUnits.
	self initializeObjectRepresentations.	
	
	self startUnit.
	
! !

!AMMStudio methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 14:10:07.642'!
initializeObjectRepresentations

	self heap: (AMMHeap new).
	self ui containerHeap addMorph: self heap.
	
	self objectgraph: (AMMObjectGraph new).
	self ui scrollAreaGraph widget: self objectgraph.
! !

!AMMStudio methodsFor: 'as yet unclassified' stamp: 'sw 5/16/2013 11:13:11.437'!
initializeUnits
	
	|subclasses|
	
	subclasses := AMMUnit allSubclasses.
	subclasses sort: [ :classA :classB | classA name asString < classB name asString ].
	self ui comboUnits 
		addItemListFrom: subclasses
		using: [:unit :listItem | 
			listItem text: unit nameOfUnit. 
			listItem data: unit. ].
		
! !

!AMMStudio methodsFor: 'as yet unclassified' stamp: 'sw 5/16/2013 10:48:04.084'!
next

	(self currentUnit isNil) 
		ifFalse: [ self currentUnit next ]! !

!AMMStudio methodsFor: 'event handling' stamp: 'sw 5/16/2013 11:09:37.836'!
nextUnit
	" start next unit "
	! !

!AMMStudio methodsFor: 'accessing' stamp: 'sw 5/13/2013 14:00:51.495'!
objectgraph

	^ objectgraph ! !

!AMMStudio methodsFor: 'accessing' stamp: 'sw 5/13/2013 14:01:26.257'!
objectgraph: anObjectgraph

	objectgraph := anObjectgraph! !

!AMMStudio methodsFor: 'as yet unclassified' stamp: 'sw 4/29/2013 12:13:42.2'!
open
	self openInWindowLabeled: 'AMM Studio'.! !

!AMMStudio methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 11:55:38.292'!
play
	
	" trigger frequently step method "! !

!AMMStudio methodsFor: 'as yet unclassified' stamp: 'sw 5/16/2013 08:42:39.928'!
refreshObjectRepresentations

	self objectgraph refresh.
	self heap refresh.! !

!AMMStudio methodsFor: 'event handling' stamp: 'sw 5/16/2013 11:15:08.932'!
registerSignalsForCurrentunit

	self connect: self currentUnit signal: #showMessage: toSelector: #showMessage: pattern: #(1).
	
	self currentUnit objects do:[ :obj |
		self connect: obj signal: #changed toSelector: #stateOfObjectChanged: pattern: #(0).
	].

	self connect: self currentUnit signal: #finished toSelector: #startNextUnit.
	! !

!AMMStudio methodsFor: 'event handling' stamp: 'sw 5/16/2013 10:47:17.556'!
registerSignalsForGeneralControls

	self connect: self ui buttonStep signal:#clicked: toSelector: #gcStep.
	self connect: self ui buttonPlay signal:#clicked: toSelector: #play.	
	self connect: self ui buttonNext signal:#clicked: toSelector: #next.! !

!AMMStudio methodsFor: 'event handling' stamp: 'sw 5/16/2013 10:34:47.95'!
showMessage: aMessage

	self ui descriptionField theText: aMessage ! !

!AMMStudio methodsFor: 'event handling' stamp: 'sw 5/16/2013 11:14:59.509'!
startNextUnit
	" start next unit "
	self halt.! !

!AMMStudio methodsFor: 'as yet unclassified' stamp: 'sw 5/16/2013 10:38:35.36'!
startUnit

	self unregisterSignalsForCurrentunit.
	
	self currentUnit: (self ui comboUnits currentItem data) new.
		
	self objectgraph objects: (self currentUnit objects).
	self heap size: self currentUnit class heapSize.
	self heap objects: (self currentUnit objects).

	self refreshObjectRepresentations.
	
	self registerSignalsForCurrentunit.

	self currentUnit start.! !

!AMMStudio methodsFor: 'event handling' stamp: 'sw 5/15/2013 10:03:12.456'!
stateOfObjectChanged: anObject

	self refreshObjectRepresentations ! !

!AMMStudio methodsFor: 'accessing' stamp: 'sw 4/29/2013 12:05:54.615'!
ui
	
	^ ui ifNil: [ ui:= AMMStudioUi new ]! !

!AMMStudio methodsFor: 'accessing' stamp: 'ci 5/10/2013 17:44:40.556'!
ui: anObject

	ui := anObject! !

!AMMStudio methodsFor: 'event handling' stamp: 'sw 5/16/2013 11:10:30.371'!
unregisterSignalsForCurrentunit

	(self currentUnit isNil) 
		ifFalse: [ 
			self currentUnit objects 
				do:[ :obj | 
					self disconnectSignal: #changed from: obj.
				].
			self disconnectSignal: #showMessage: from: self currentUnit.
			self disconnectSignal: #finished  from: self currentUnit.
			
		].
! !

Morph subclass: #AMMTestConnect
	instanceVariableNames: 'obj1 obj2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMTestConnect methodsFor: 'as yet unclassified' stamp: 'ci 5/13/2013 20:02:13.705'!
clickedObj1
	Transcript show: 'Clicked Objekt # 1';cr.! !

!AMMTestConnect methodsFor: 'as yet unclassified' stamp: 'ci 5/13/2013 20:13:12.101'!
clickedObj2: evt
	Transcript show: 'Clicked Objekt # 2';cr.! !

!AMMTestConnect methodsFor: 'as yet unclassified' stamp: 'ci 5/13/2013 20:36:49.91'!
initialize
	super initialize.
	
	self obj1:  UiPushButton new.
	self obj1 position: 5@5.
	self obj1 text: 'Send!!'.
	self obj2: Morph new.
	self obj2 position: 100@5.
	self 
		extent: 400@400;
		color: Color gray;
		addMorph: obj1;
		addMorph: obj2.
		
	self connect: self obj1 signal:#clicked: toSelector: #clickedObj1.
	self obj2 on:#mouseDown send:#clickedObj2: to:self.! !

!AMMTestConnect methodsFor: 'accessing' stamp: 'ci 5/13/2013 19:56:59.507'!
obj1

	^ obj1! !

!AMMTestConnect methodsFor: 'accessing' stamp: 'ci 5/13/2013 19:56:59.52'!
obj1: anObject

	obj1 := anObject! !

!AMMTestConnect methodsFor: 'accessing' stamp: 'ci 5/13/2013 19:56:59.532'!
obj2

	^ obj2! !

!AMMTestConnect methodsFor: 'accessing' stamp: 'ci 5/13/2013 19:56:59.548'!
obj2: anObject

	obj2 := anObject! !

UiTestCase subclass: #AMMObjectGraphTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio-Test'!

!AMMObjectGraphTest class methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 12:49:52.069'!
exampleCollectionWithoutCircularyDepencies
	
	| objA objB objC coll |
	objA := AMMObject new size: 8.
	objB := AMMObject new size: 20.
	objC := AMMObject new size: 5.
	objA references add: objB; add:objC.	

	coll := OrderedCollection new
		add: objA; 
		add: objB;
		add: objC;
		yourself.
	^ coll! !

!AMMObjectGraphTest methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 11:03:38.691'!
subjectClass

	^ AMMObjectGraph! !

!AMMObjectGraphTest methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 11:06:11.201'!
testANewObjectGraphHasNoNodes

	self assert: sut objectNodes size == 0.
	self assert: sut submorphs size == 0.
	! !

!AMMObjectGraphTest methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 14:26:42.366'!
testRenderingConnectsNodes
	

	sut objects: self class exampleCollectionWithoutCircularyDepencies.
	
	self assert: sut objectNodes isEmpty.

	sut render.
	self deny: sut objectNodes isEmpty.
	! !

!AMMObjectGraphTest methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 11:13:52.694'!
testRenderingCreatesObjectNodes
	
	sut objects add: (AMMObject new size: 8).
	self assert: sut objectNodes isEmpty.
	sut render.
	self deny: sut objectNodes isEmpty.
	! !

!AMMObjectGraphTest methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 14:26:57.258'!
testRenderingPreservesObjects
	
	self assert: sut objects isEmpty.
	sut objects: self class exampleCollectionWithoutCircularyDepencies.
	self deny: sut objects isEmpty.
	sut render.
	self deny: sut objects isEmpty.	! !

PasteUpMorph subclass: #AMMObjectsRepresentation
	instanceVariableNames: 'studio objects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

AMMObjectsRepresentation subclass: #AMMHeap
	instanceVariableNames: 'heapCollection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMHeap class methodsFor: 'as yet unclassified' stamp: 'rm 5/6/2013 15:15:08.484'!
withSize: aHeapSize

	| heap |
	heap := AMMHeap new.
	heap extent: ((aHeapSize*10)@100);
		borderWidth: 0;
		color: Color transparent.
	1 to: aHeapSize do: [ :cellNumber | 
		| cell |
		cell := AMMHeapCell withId: cellNumber.
		cell position: ( (10*(cellNumber-1)) @ 0).
		cell lock.
		heap heapCollection add: cell.
	].
	^ heap! !

!AMMHeap methodsFor: 'rendering' stamp: 'sw 5/13/2013 13:49:10.491'!
clear

	" remove all submorphs and empty all dictionaries/ collections"
	
	self heapCollection do: [ :element |
			element reset.
			element delete.
		] ! !

!AMMHeap methodsFor: 'rendering' stamp: 'sw 5/13/2013 13:49:38.457'!
create
	"create entries for all objects"
	
	self heapCollection do: [ :element |
			self addMorph: element.
		]
	! !

!AMMHeap methodsFor: 'accessing' stamp: 'sw 5/6/2013 10:10:44.341'!
heapCollection
	
	 ^ heapCollection ifNil: [ heapCollection := OrderedCollection new ]! !

!AMMHeap methodsFor: 'accessing' stamp: 'ci 5/10/2013 17:47:45.901'!
heapCollection: anObject

	heapCollection := anObject! !

!AMMHeap methodsFor: 'accessing' stamp: 'sw 5/6/2013 10:10:59.241'!
heapSize

	^ self heapCollection size! !

!AMMHeap methodsFor: 'rendering' stamp: 'sw 5/15/2013 10:12:09.895'!
mapObjectsToHeap
	" iterates over objects and marks used heap cells "
	
	self objects do: [ :object |
			| cell |
			0 to: (object size - 1) do: [ :offset |
				(self heapCollection size >= (object address + offset)) ifTrue: [
					cell := self heapCollection at: (object address + offset). 
					cell setStatus: 2.
					cell object: object.
				]
			]
		]! !

!AMMHeap methodsFor: 'rendering' stamp: 'sw 5/15/2013 10:16:44.35'!
refresh

	self heapCollection 
		do:[ :cell | cell refresh ].! !

!AMMHeap methodsFor: 'rendering' stamp: 'sw 5/13/2013 13:50:42.255'!
render
	
	self mapObjectsToHeap.
	self create.! !

!AMMHeap methodsFor: 'rendering' stamp: 'sw 5/13/2013 14:06:24.471'!
size: aHeapSize

	self extent: ((aHeapSize*10)@100);
		borderWidth: 0;
		color: Color transparent.
	1 to: aHeapSize do: [ :cellNumber | 
		| cell |
		cell := AMMHeapCell withId: cellNumber.
		cell position: ( (10*(cellNumber-1)) @ 0).
		cell lock.
		self heapCollection add: cell.
	]! !

AMMObjectsRepresentation subclass: #AMMObjectGraph
	instanceVariableNames: 'objectNodes layoutAlgorithm'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMObjectGraph methodsFor: 'as yet unclassified' stamp: 'sw 5/16/2013 08:41:34.735'!
addNodes
"Create one ObjectNode for every object and register the morph in the temporary storage"

	self objects do:[ :obj |
	|node|
		node := AMMObjectNode newFor: obj.
		node object state = #marked ifTrue: [ node color: Color green. ].	
		self objectNodes at: obj put: node.
		self addMorph: node.
	].

! !

!AMMObjectGraph methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 14:16:38.383'!
clear

	self layoutAlgorithm delete.
	self removeNodes.
	! !

!AMMObjectGraph methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 12:40:23.524'!
connectNode: node with: anotherNode

	| connection |
	connection := NCAAConnectorMorph fromMorph: node toMorph: anotherNode.
	connection makeForwardArrow.
	self addMorph: connection.
	! !

!AMMObjectGraph methodsFor: 'as yet unclassified' stamp: 'ci 5/10/2013 18:15:29.957'!
connectNodes

	self objects do:[ 
		:obj|
		self connectReferences: obj. 
		]! !

!AMMObjectGraph methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 11:13:15.443'!
connectReferences: anObject

	| node |
	node := self objectNodes at: anObject.
	anObject references do: [ :ref |
		| referencedNode |
		referencedNode :=  self objectNodes at: ref.
		self connectNode: node with: referencedNode.
		]
	
	! !

!AMMObjectGraph methodsFor: 'submorphs-add/remove' stamp: 'sw 5/6/2013 19:48:36.428'!
delete

	self clear.
	super delete.! !

!AMMObjectGraph methodsFor: 'initialization' stamp: 'ci 5/13/2013 17:19:58.113'!
initialize 

	super initialize.
	self 
		extent: 400@400;
		color: Color transparent;
	 	borderWidth: 0.! !

!AMMObjectGraph methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 13:40:23.548'!
layoutAlgorithm

	^ layoutAlgorithm ifNil: [ layoutAlgorithm := AMMGraphLayoutAlgorithm new.]
! !

!AMMObjectGraph methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 19:48:20.328'!
layoutNodes
	WorldState
		addDeferredUIMessage: 
[ self layoutAlgorithm layoutMorph: self]
! !

!AMMObjectGraph methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 11:05:48.348'!
objectNodes

	^ objectNodes ifNil: [ objectNodes := Dictionary new.]! !

!AMMObjectGraph methodsFor: 'as yet unclassified' stamp: 'sw 5/16/2013 08:40:04.618'!
refresh 
	Transcript show:'refresh object graph'; cr.
	self objectNodes do: [ :node |
		node refresh.
		].! !

!AMMObjectGraph methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 10:02:13.946'!
removeNodes 

	self removeAllMorphs.
	self objectNodes keysDo: [:key | self objectNodes removeKey: key ]! !

!AMMObjectGraph methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 19:48:31.14'!
render

	self addNodes.
	self connectNodes.
	self layoutNodes.
! !

!AMMObjectGraph methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 12:41:50.661'!
runGraph

	WorldState
		addDeferredUIMessage: [self layoutAlgorithm layoutMorph: self]
layoutNodes

	"move nodes"! !

!AMMObjectsRepresentation methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 10:00:57.498'!
clear
	^ self subclassResponsibility ! !

!AMMObjectsRepresentation methodsFor: 'accessing' stamp: 'ci 5/10/2013 18:17:34.105'!
objects

	^ objects ifNil: [ objects:= OrderedCollection  new ]! !

!AMMObjectsRepresentation methodsFor: 'accessing' stamp: 'sw 5/15/2013 10:07:21.553'!
objects: anObject

	self clear.

	objects := anObject.

	self render.! !

!AMMObjectsRepresentation methodsFor: 'as yet unclassified' stamp: 'sw 5/15/2013 10:07:40.779'!
refresh

	self subclassResponsibility ! !

!AMMObjectsRepresentation methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 09:46:42.197'!
render
	^ self subclassResponsibility ! !

!AMMObjectsRepresentation methodsFor: 'accessing' stamp: 'ci 5/10/2013 17:56:19.769'!
studio

	^ studio! !

!AMMObjectsRepresentation methodsFor: 'accessing' stamp: 'ci 5/10/2013 17:56:19.78'!
studio: anObject

	studio := anObject! !

TestCase subclass: #AMMGCAlgorithmTest
	instanceVariableNames: 'sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio-Test'!

!AMMGCAlgorithmTest methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 14:49:11.736'!
exampleObjects
	
| objA objB objC coll objD |
	objA := AMMObject new size: 8 ; address: 1; yourself.
	objB := AMMObject new size: 20 ; address: 10; yourself.
	objC := AMMObject new size: 5 ; address: 32; yourself.
	objD := AMMObject new size: 5 ; address: 37; yourself.

	objA isRoot: true.
	
	objA references add: objB; add:objC.	

	coll := OrderedCollection new
		add: objA; 
		add: objB;
		add: objC;
		add: objD;
		yourself.

	^ coll! !

!AMMGCAlgorithmTest methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 15:23:53.463'!
exampleObjectsWithOnlyOneChild
	
| objA objB objC coll objD |
	objA := AMMObject new size: 8 ; address: 1; yourself.
	objB := AMMObject new size: 20 ; address: 10; yourself.
	objC := AMMObject new size: 5 ; address: 32; yourself.
	objD := AMMObject new size: 5 ; address: 37; yourself.

	objA isRoot: true.
	
	objA references add: objB.

	coll := OrderedCollection new
		add: objA; 
		add: objB;
		add: objC;
		add: objD;
		yourself.

	^ coll! !

!AMMGCAlgorithmTest methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 19:09:47.004'!
exampleObjectsWithOrphan
	
| objA objB coll objC |
	objA := AMMObject new size: 8 ; address: 1; yourself.
	objB := AMMObject new size: 20 ; address: 10; yourself.
	objC := AMMObject new size: 20 ; address: 10; yourself.
	
	objA isRoot: true.
	objA references add: objB.
	
	coll := OrderedCollection new
		add: objA; 
		add: objB;
		add: objC;
		
		yourself.



	^ coll! !

!AMMGCAlgorithmTest methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 15:43:45.55'!
exampleObjectsWithTwoRoots
	
| objA objB coll |
	objA := AMMObject new size: 8 ; address: 1; yourself.
	objB := AMMObject new size: 20 ; address: 10; yourself.
	
	objA isRoot: true.
	
	objB isRoot: true.
	
	coll := OrderedCollection new
		add: objA; 
		add: objB;
		yourself.

	^ coll! !

!AMMGCAlgorithmTest methodsFor: 'as yet unclassified' stamp: 'sw 5/9/2013 12:56:53.589'!
setUp 

	sut := AMMGCAlgorithm new.
	sut objects: self exampleObjects.! !

!AMMGCAlgorithmTest methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 15:14:15.315'!
test010EnterChildOfFirstNode

	| objA objB |
	objA := sut nextObject. 
	
	self assert: (objA == (sut objects at:1)).
	self assert: (objA flag = #activeTraversal). " state is changed "
	
	self assert: ((objA references at:1) flag = #new). " state is still active "
	
	objB := sut nextObject. 
	
	self assert: (objA flag = #activeTraversal). " state is still active "
	
	self assert: (objB == (objA references at:1)).

	self assert: (objB flag = #activeTraversal).
! !

!AMMGCAlgorithmTest methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 15:46:30.414'!
test011ReturnToParentNodeAndContinue

	| objA objB objC |
	sut objects: self exampleObjectsWithOnlyOneChild.
	
	objA := sut nextObject. 
	objB := sut nextObject. 
	
	self assert: (objA flag = #activeTraversal). " state is still active "
	self assert: (objB flag = #activeTraversal).
	
	objC := sut nextObject. 
	
	self assert: (objC = nil).
	
	self assert: (objA flag = #doneTraversal). " state is left "
	self assert: (objB flag = #doneTraversal). " state is left "! !

!AMMGCAlgorithmTest methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 19:07:48.381'!
test020EnterTwoRoots

	| objA objB objC |
	sut objects: self exampleObjectsWithTwoRoots.
	
	objA := sut nextObject. 
	self assert: (objA flag = #activeTraversal). " state is still active "
	self assert: (objA = (sut objects at:1)).
	
	objB := sut nextObject. 
	self assert: (objB = (sut objects at:2)).
	self assert: (objB flag = #activeTraversal).

	self assert: (objA flag = #doneTraversal). " state is still active "
	
	objC := sut nextObject. 
	
	self assert: (objC = nil).
	
! !

!AMMGCAlgorithmTest methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 19:11:06.447'!
test030DoNotVisitOrphanObject

	| objA objB objC |
	sut objects: self exampleObjectsWithOrphan.
	
	objA := sut nextObject. 
	self assert: (objA = (sut objects at:1)).
	
	objB := sut nextObject. 
	self assert: (objB = (sut objects at:2)).

	objC := sut nextObject. 
	
	self assert: (objC = nil).
	
! !

!AMMGCAlgorithmTest methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 15:09:58.91'!
testFirstVisitedObjectGetsEntered

	| obj |
	obj := sut nextObject. 
	
	self assert: (obj == (sut objects at:1)).
	self assert: (obj flag == #activeTraversal).

	" first object is in the stack "
	self assert: ((sut objectStack orderedKeys last) == obj).
	
	" children counter is zero "
	self assert: ((sut objectStack at: obj) == 0).
	! !

Object subclass: #AMMGCAlgorithm
	instanceVariableNames: 'objects objectStack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMGCAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 19:17:08.483'!
enter: anObject

	self objectStack at: anObject put: 0.
	anObject flag: #activeTraversal.! !

!AMMGCAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 15:37:39.093'!
findNextUntraversedRoot
	" returns first object which hasn't been traversed yet and is a root - therefore globally reachable "

	self objects 
		do:[ :obj | 
				(obj hasBeenTraversed = false and: ( obj isRoot)) 
					ifTrue: [ ^ obj ] 
			].
	^ nil
		! !

!AMMGCAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/9/2013 12:46:50.838'!
finishStage

	(self currentStage == #clearStates) ifTrue: [ self currentStage: #traverse ].
	(self currentStage == #traverse) ifTrue: [ self currentStage: #removeObjects ].
	(self currentStage == #removeObjects) ifTrue: [  self currentStage: #done ].
	! !

!AMMGCAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 19:26:20.184'!
indexOfLastChildOf: anObject

	^ self objectStack at: anObject! !

!AMMGCAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 19:23:42.31'!
lastVisitedObject

	^ self objectStack orderedKeys last! !

!AMMGCAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 19:19:54.82'!
leave: anObject

	self objectStack removeKey: anObject.
	anObject flag: #doneTraversal.! !

!AMMGCAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 19:32:24.811'!
nextChildOf: object
	| nextChild  index | 
	
	index := self indexOfLastChildOf: object.
	nextChild :=  object references at: (index +1) ifAbsent: nil.
	self objectStack at: object put:(index +1).

	^ nextChild! !

!AMMGCAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 19:31:04.376'!
nextObject
| object |
	self objectStack isEmpty 
		ifTrue: [
		"no parent-object is on the stack"
			object := self findNextUntraversedRoot.
			(object isNil) 
				ifFalse: [ self enter: object ].
		] ifFalse: [
		
			object := self nextChildOf: self lastVisitedObject.			
			(object isNil)
				ifTrue: [ 
					" last reference of object was visited, we can leave the object now"
					self leave:  self lastVisitedObject. 
					object := self nextObject.
					] 
				ifFalse: [
					object hasBeenTraversed 
						ifTrue:  [ object := self nextObject.] 
						ifFalse: [ self enter: object ].			
					].
			].
		^ object
! !

!AMMGCAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/9/2013 12:44:01.09'!
objectStack
	^ objectStack ifNil: [ objectStack := OrderedKeysIdentityDictionary new ]! !

!AMMGCAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/9/2013 10:41:30.436'!
objects 
	^ objects! !

!AMMGCAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/9/2013 10:41:15.423'!
objects: anCollection
	objects := anCollection! !

!AMMGCAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 15:11:40.486'!
reset
	self objects do: [ :obj | obj flag: #new ].
	self currentStage: #clearStates.
	self objectStack removeAll.
	! !

!AMMGCAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 13:47:17.103'!
step
	^ self subclassResponsibility ! !

AMMGCAlgorithm subclass: #AMMMarkAndSweap
	instanceVariableNames: 'currentStage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMMarkAndSweap methodsFor: 'as yet unclassified' stamp: 'sw 5/9/2013 11:43:27.464'!
clearAllStates
	"clear all flags of the objects"! !

!AMMMarkAndSweap methodsFor: 'as yet unclassified' stamp: 'sw 5/9/2013 11:42:06.508'!
currentStage

	^ currentStage! !

!AMMMarkAndSweap methodsFor: 'as yet unclassified' stamp: 'sw 5/9/2013 11:41:59.923'!
currentStage: aSymbol

	currentStage := aSymbol! !

!AMMMarkAndSweap methodsFor: 'as yet unclassified' stamp: 'sw 5/9/2013 11:45:18.42'!
removeUnusedObjects! !

!AMMMarkAndSweap methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 13:48:02.171'!
step 
	" 0. -> clear all states of objects -> 1. Tree traversal -> 2. remove unreferenced objects "

	(self currentStage == #clearStates) ifTrue: [ self clearAllStates ].
	(self currentStage == #traverse) ifTrue: [ self traverseTree ].
	(self currentStage == #removeObjects) ifTrue: [ self removeUnusedObjects ].
	
! !

!AMMMarkAndSweap methodsFor: 'as yet unclassified' stamp: 'sw 5/9/2013 11:43:53.583'!
traverseTree! !

Object subclass: #AMMObject
	instanceVariableNames: 'references size address state flag isRoot studio'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMObject methodsFor: 'accessing' stamp: 'rm 5/6/2013 13:47:02.404'!
address

	^ address! !

!AMMObject methodsFor: 'accessing' stamp: 'rm 5/6/2013 13:46:46.902'!
address: anAddress

	address := anAddress.! !

!AMMObject methodsFor: 'event-handling' stamp: 'sw 5/15/2013 09:46:01.333'!
changed

	self emit.! !

!AMMObject methodsFor: 'accessing' stamp: 'sw 5/9/2013 12:35:16.035'!
flag
	" is used for the garbage collection algorithms"
	^flag! !

!AMMObject methodsFor: 'accessing' stamp: 'sw 5/9/2013 12:35:13.053'!
flag: aSymbol
	" is used for the garbage collection algorithms"
	flag := aSymbol.! !

!AMMObject methodsFor: 'accessing' stamp: 'sw 5/13/2013 15:12:55.847'!
hasBeenTraversed

	^ (self flag == #doneTraversal) or: (self flag == #activeTraversal) ! !

!AMMObject methodsFor: 'initialize-release' stamp: 'sw 5/15/2013 09:58:10.281'!
initialize 

	super initialize.

	self flag: #new.
	self isRoot: false.! !

!AMMObject methodsFor: 'accessing' stamp: 'sw 5/13/2013 14:36:05.021'!
isRoot

	^ isRoot! !

!AMMObject methodsFor: 'accessing' stamp: 'sw 5/13/2013 14:36:05.027'!
isRoot: anObject

	isRoot := anObject! !

!AMMObject methodsFor: 'accessing' stamp: 'sw 5/6/2013 10:39:51.902'!
references
	
	^ references ifNil: [ references := OrderedCollection new]! !

!AMMObject methodsFor: 'accessing' stamp: 'sw 5/13/2013 14:36:05.014'!
references: anObject

	references := anObject! !

!AMMObject methodsFor: 'accessing' stamp: 'sw 5/6/2013 10:40:30.616'!
size
	
	^ size! !

!AMMObject methodsFor: 'accessing' stamp: 'sw 5/6/2013 10:40:46.006'!
size: aSize
	
	size := aSize.! !

!AMMObject methodsFor: 'accessing' stamp: 'sw 5/9/2013 12:34:17.707'!
state
	" is used for grafical representation "
	^ state! !

!AMMObject methodsFor: 'accessing' stamp: 'sw 5/15/2013 09:56:03.362'!
state: aState
	" is used for graphical representation "

	state := aState.
	
	self changed.! !

!AMMObject methodsFor: 'accessing' stamp: 'ci 5/13/2013 17:48:12.558'!
studio
	^studio! !

!AMMObject methodsFor: 'accessing' stamp: 'ci 5/13/2013 17:48:04.379'!
studio: aAMMStudio
	" needed for callback when representation is clicked "

	studio := aAMMStudio.! !

!AMMObject methodsFor: 'accessing' stamp: 'sw 5/15/2013 09:55:38.274'!
toggleState 

	(self state = #marked) 
		ifTrue: [
			self state: #unmarked.
		 ]
	 	ifFalse: [
			self state: #marked.
		].! !

Object subclass: #AMMUnit
	instanceVariableNames: 'objects state stepCount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMUnit class methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 13:57:49.277'!
heapSize

	self subclassResponsibility ! !

!AMMUnit class methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 11:45:19.383'!
nameOfUnit

	self subclassResponsibility ! !

!AMMUnit methodsFor: 'accessing' stamp: 'sw 5/16/2013 11:11:33.487'!
finished
	
	self emit.! !

!AMMUnit methodsFor: 'accessing' stamp: 'sw 5/16/2013 10:44:08.146'!
initialize 
	
	self stepCount: 0.
	self state: #initial.! !

!AMMUnit methodsFor: 'as yet unclassified' stamp: 'sw 5/16/2013 10:45:32.673'!
next
	self subclassResponsibility 
	! !

!AMMUnit methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 11:52:10.238'!
objects

	self subclassResponsibility ! !

!AMMUnit methodsFor: 'accessing' stamp: 'ci 5/13/2013 17:50:20.306'!
objects: anObject

	objects := anObject! !

!AMMUnit methodsFor: 'accessing' stamp: 'sw 5/16/2013 10:19:23.847'!
showMessage: aMessage

	self emit.! !

!AMMUnit methodsFor: 'as yet unclassified' stamp: 'sw 5/16/2013 11:05:13.987'!
start

	self subclassResponsibility.! !

!AMMUnit methodsFor: 'accessing' stamp: 'sw 5/16/2013 10:45:03.167'!
state

	^ state
	
	"new -> #new
	 started -> #started "! !

!AMMUnit methodsFor: 'accessing' stamp: 'sw 5/16/2013 10:43:56.232'!
state: anObject

	state := anObject! !

!AMMUnit methodsFor: 'as yet unclassified' stamp: 'sw 5/16/2013 10:59:30.784'!
step

	self subclassResponsibility 
! !

!AMMUnit methodsFor: 'accessing' stamp: 'sw 5/16/2013 10:37:15.145'!
stepCount

	^ stepCount! !

!AMMUnit methodsFor: 'accessing' stamp: 'sw 5/16/2013 10:37:15.148'!
stepCount: anObject

	stepCount := anObject! !

AMMUnit subclass: #AMMUnit0
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMUnit0 class methodsFor: 'as yet unclassified' stamp: 'sw 5/16/2013 10:57:52.28'!
heapSize 

	^ 0! !

!AMMUnit0 class methodsFor: 'as yet unclassified' stamp: 'sw 5/16/2013 10:50:11.957'!
nameOfUnit

	^ 'Welcome'! !

!AMMUnit0 methodsFor: 'as yet unclassified' stamp: 'sw 5/16/2013 11:05:48.921'!
introduceElements
	
	self state: #elements.
	self showMessage:
'You can see various elements here.

Just click next to continue!!'.! !

!AMMUnit0 methodsFor: 'as yet unclassified' stamp: 'sw 5/16/2013 11:07:46.026'!
introduceUnits

	self state: #unitsIntroduced.
	self showMessage:
'You have unlimited units here. 

Just click next to start with your first lecture!!!!'.! !

!AMMUnit0 methodsFor: 'as yet unclassified' stamp: 'sw 5/16/2013 11:17:12.6'!
next 

	(self state == #started) 
		ifTrue: [ self introduceElements ]
		ifFalse: [
			(self state == #elements) 
				ifTrue: [ self introduceUnits ]
				ifFalse: [	
					(self state == #unitsIntroduced) 
						ifTrue: [ self finished ].					
					]
			]
! !

!AMMUnit0 methodsFor: 'as yet unclassified' stamp: 'sw 5/16/2013 11:04:05.807'!
objects 

	^ objects ifNil: [ objects := OrderedCollection new ]! !

!AMMUnit0 methodsFor: 'as yet unclassified' stamp: 'sw 5/16/2013 11:05:03.831'!
start 

	self state: #started.
	self welcome.! !

!AMMUnit0 methodsFor: 'as yet unclassified' stamp: 'sw 5/16/2013 11:02:50.416'!
welcome

	self showMessage:
'Hello JonDoe,
You can learn how the mark and sweep algorithm works here. 

Just click next to continue!!'.! !

AMMUnit subclass: #AMMUnit1
	instanceVariableNames: 'algorithm'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMUnit1 class methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 14:19:11.438'!
heapSize 

	^ 45! !

!AMMUnit1 class methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 11:44:55.082'!
nameOfUnit

	^ 'Unit #1'! !

!AMMUnit1 methodsFor: 'accessing' stamp: 'sw 5/13/2013 13:41:12.697'!
algorithm

	^ algorithm! !

!AMMUnit1 methodsFor: 'accessing' stamp: 'sw 5/13/2013 13:41:12.706'!
algorithm: anObject

	algorithm := anObject! !

!AMMUnit1 methodsFor: 'as yet unclassified' stamp: 'sw 5/15/2013 09:39:45.983'!
initialize 

	super initialize.
	self algorithm: AMMMarkAndSweap new.! !

!AMMUnit1 methodsFor: 'as yet unclassified' stamp: 'sw 5/16/2013 10:35:32.063'!
objects 

	^ objects ifNil: [
	| objA objB objC coll objD |
	objA := AMMObject new size: 8 ;  address: 1; isRoot: true; yourself.
	objB := AMMObject new size: 20 ; address: 10; yourself.
	objC := AMMObject new size: 5 ;  address: 32; yourself.
	objD := AMMObject new size: 5 ; address: 37; yourself.

	objA isRoot: true.
	
	objA references add: objB; add:objC.	

	coll := OrderedCollection new
		add: objA; 
		add: objB;
		add: objC;
		add: objD;
		yourself.
	objects := coll.
	]! !

!AMMUnit1 methodsFor: 'as yet unclassified' stamp: 'sw 5/16/2013 11:05:27.076'!
start 

	self state: #started.
	self showMessage:
'Hello JonDoe,
You can learn how the mark and sweep algorithm works here. 

Just click next to continue!!'.! !

!AMMUnit1 methodsFor: 'as yet unclassified' stamp: 'sw 5/16/2013 10:36:17.899'!
step
	
	super step.
	self algorithm step.! !

!OrderedKeysIdentityDictionary methodsFor: '*AMMStudio' stamp: 'sw 5/9/2013 13:16:13.633'!
at: key put: anObject 
	(self includesKey: key) 
		ifFalse: [
		self orderedKeys add: key.
		].
	super at: key put: anObject.
	! !

!OrderedKeysIdentityDictionary methodsFor: '*AMMStudio' stamp: 'sw 5/9/2013 13:17:21.275'!
removeKey: key 

	self orderedKeys remove: key.
	^ super removeKey: key.	
! !

RectangleMorph subclass: #AMMHeapCell
	instanceVariableNames: 'id object'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMHeapCell class methodsFor: 'as yet unclassified' stamp: 'ci 5/10/2013 11:25:56.475'!
withId: aNumber
	| cell |
	cell := self new.
	cell extent: (10 @ 92).
	cell color: Color blue.
	cell borderWidth: 1.
	cell id: aNumber.
	^ cell.! !

!AMMHeapCell methodsFor: 'accessing' stamp: 'rm 5/6/2013 13:22:06.905'!
id
	^ id.! !

!AMMHeapCell methodsFor: 'accessing' stamp: 'rm 5/6/2013 13:24:54.733'!
id: aNumber
	id := aNumber.! !

!AMMHeapCell methodsFor: 'accessing' stamp: 'ci 5/13/2013 17:56:37.144'!
object

	^ object! !

!AMMHeapCell methodsFor: 'accessing' stamp: 'sw 5/15/2013 10:13:21.867'!
object: anObject

	object := anObject.

	self setColor.! !

!AMMHeapCell methodsFor: 'accessing' stamp: 'sw 5/15/2013 10:16:17.794'!
refresh 

	self setColor.
	! !

!AMMHeapCell methodsFor: 'logic' stamp: 'rm 5/6/2013 15:06:58.379'!
reset
	self setStatus: 1.! !

!AMMHeapCell methodsFor: 'accessing' stamp: 'sw 5/15/2013 10:18:07.565'!
setColor
	
	(self object isNil) 
		ifTrue: [ self color: Color gray ] 
		ifFalse: [
			(self object state = #marked) 
				ifTrue: [ self color: Color green ]
				ifFalse: [ self color: Color blue ]
		]
	! !

!AMMHeapCell methodsFor: 'logic' stamp: 'rm 5/6/2013 15:04:46.403'!
setStatus: aState

	(aState == 1) ifTrue: [ self color: Color blue].
	(aState == 2) ifTrue: [ self color: Color red].! !

NCEllipseMorph subclass: #AMMObjectNode
	instanceVariableNames: 'object'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMObjectNode class methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 13:32:57.212'!
defaultBorderWidth 

	^ 3! !

!AMMObjectNode class methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 13:32:57.219'!
defaultHeight 

	^ 50
	
! !

!AMMObjectNode class methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 13:32:57.226'!
defaultWidth

	^ 50
	
! !

!AMMObjectNode class methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 13:32:57.232'!
newFor: anObject
	| node|
	
	node := self new.
	node object: anObject.
	
	^ node! !

!AMMObjectNode methodsFor: 'event handling' stamp: 'sw 5/15/2013 09:55:14.899'!
click

	self object toggleState.
	! !

!AMMObjectNode methodsFor: 'initialization' stamp: 'sw 5/15/2013 09:59:50.012'!
initialize 

	super initialize.

	self color: Color white.
	self borderWidth: self class defaultBorderWidth.
	self removeAllMorphs.
	self height: self class defaultHeight.
	self width: self class defaultWidth.
	
	self on: #mouseDown send: #click to: self.
	! !

!AMMObjectNode methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 13:32:57.198'!
object

	^ object! !

!AMMObjectNode methodsFor: 'as yet unclassified' stamp: 'sw 5/15/2013 10:15:11.027'!
object: anObject

	object := anObject.
	self setColor.! !

!AMMObjectNode methodsFor: 'as yet unclassified' stamp: 'sw 5/16/2013 08:40:10.394'!
refresh 

	self setColor.! !

!AMMObjectNode methodsFor: 'as yet unclassified' stamp: 'sw 5/15/2013 10:15:52.876'!
setColor 

	(self object isRoot)
	 ifTrue: [ self borderColor: Color red; 
		   			  borderWidth: self class defaultBorderWidth ].
	
	(self object state = #marked) 
		ifTrue: [ self color: Color green ]
		ifFalse: [ self color: Color white ].! !
